
!NaturalLanguageTranslator class methodsFor: '*TransTSV' stamp: 'mu 7/14/2007 12:23'!
loadAndStoreTranslationOf: packageName lang: langString path: urlString ifFailedRead: enclosingZip 
	"NaturalLanguageTranslator loadAndStoreTranslationOf: 'NetMorph' lang: 'ja' path: 'ftp://swikis.ddo.jp/NetMorph/translations' ifFailedRead: nil"
	| transName zip |
	transName := packageName, '.' , langString , '.trans'.
	[| url path mime | 
	path := (urlString endsWith: '/') ifTrue: [urlString] ifFalse: [urlString, '/'].
	url := (path, transName, '.zip') asUrl.
	mime := url retrieveContents.
	zip := ZipArchive new readFrom: mime contents asByteArray readStream]
		on: Error
		do: [:ex | zip := enclosingZip].
	zip extractMember: transName toFileNamed: transName.
	NaturalLanguageTranslator mergeTSVFileNamed: transName
		! !

!NaturalLanguageTranslator class methodsFor: '*TransTSV' stamp: 'mu 4/13/2006 11:31'!
loadTranslationOf: packageName lang: langString path: urlString ifFailedRead: enclosingZip 
	"NaturalLanguageTranslator loadTranslationOf: 'NetMorph' lang: 'ja' path: 'ftp://swikis.ddo.jp/NetMorph/translations' ifFailedRead: nil"
	| rand transName randomFileName zip |
	rand := 99999 atRandom asString.
	transName := packageName, '.' , langString , '.trans'.
	randomFileName := rand , transName.
	[| url path mime | 
	path := (urlString endsWith: '/') ifTrue: [urlString] ifFalse: [urlString, '/'].
	url := (path, transName, '.zip') asUrl.
	mime := url retrieveContents.
	zip := ZipArchive new readFrom: mime contents asByteArray readStream]
		on: Error
		do: [:ex | zip := enclosingZip].
	[zip extractMember: transName toFileNamed: randomFileName.
	NaturalLanguageTranslator mergeTSVFileNamed: randomFileName]
		ensure: [FileDirectory default deleteFileNamed: randomFileName]! !

!NaturalLanguageTranslator class methodsFor: '*TransTSV' stamp: 'mu 10/19/2005 09:27'!
mergeTSVFileNamed: filename 
	"merge the tab separated text file"
	"NaturalLanguageTranslator mergeTSVFileNamed: 'NetMorph.ja.trans'"
	| fileFullNameString stream localeID translator |
	fileFullNameString := (filename findTokens: FileDirectory slash) size = 0
				ifTrue: [FileDirectory default fullNameFor: filename]
				ifFalse: [filename].
	stream := FileStream readOnlyFileNamed: fileFullNameString.
	stream wantsLineEndConversion: true.
	[localeID := LocaleID isoString: (stream localName findTokens: '.') second.
	translator := self localeID: localeID.
	translator mergeTSVFrom: stream]
		ensure: [stream close].
	"LanguageEnvironment resetKnownEnvironments"! !

!NaturalLanguageTranslator methodsFor: '*TransTSV' stamp: 'mu 4/13/2006 11:32'!
mergeTSVFrom: aStream 
	"Read a definition of dictionary. 
	Make sure current locale corresponds my locale id"
	| aString newTranslations token currentPlatform dict |
	newTranslations := Dictionary new.
	token := Character tab asString.
	currentPlatform := Locale currentPlatform.
	[Locale
		currentPlatform: (Locale localeID: id).
	[aStream atEnd]
		whileFalse: [aString := aStream nextLine.
			(aString isEmpty
					or: [aString first == $#])
				ifFalse: [| keyAndValue | 
					keyAndValue := aString findTokens: token.
					keyAndValue size = 1
						ifTrue: [self class registerPhrase: keyAndValue first]
						ifFalse: [newTranslations add: keyAndValue first -> keyAndValue second]]]]
		ensure: [Locale currentPlatform: currentPlatform].
	dict := Dictionary new.
	(newTranslations associations do: [:each | dict add: (Compiler evaluate: each asString)]).
	self mergeTranslations: dict! !
